<template>
  <div class="app-container">
    <!-- 公司级培训跟踪矩阵对话框 -->
    <div>
      <svg-icon class="rectangleGreen" icon-class="rectangleGreen"></svg-icon>
      <span>{{ $t('需参加培训，已经完成培训人员') }}</span>
      <svg-icon class="rectangleRed" icon-class="rectanglered"></svg-icon>
      <span style="line-height: 40px">{{ $t('需参加培训，尚未进行培训人员') }}</span>
      <span style="line-height: 40px;margin-left: 22px;">╳ 需要参加培训</span>
      <span style="line-height: 40px;margin-left: 22px;">⚪ 不需要参加培训</span>
    </div>

    <vue-draggable-resizable :draggable="dragMove" h="auto" style="background-color:white" w="auto" @resize="onResize">
      <div ref="branch" class="zoom" @wheel.prevent="handleTableWheel($event)">
        <el-table v-if="tableShow" ref="companyTable" v-loading="companyTrainingLoad"
                  :cell-class-name="tableCellClassName"
                  :data="companylevelList" :height="height-100" :row-style="{height:'40px'}"
                  :span-method="colspanMethod"
                  border
                  class="companyLevelTable"
        >
          <el-table-column :label="$t('课程代码')" align="center" fixed width="80">
            <template slot-scope="scope">
              {{ scope.row[0] }}
            </template>
          </el-table-column>
          <el-table-column :label="$t('公司级') + $t('空格') +$t('培训课程') + $t('空格') + $t('名称')" align="center"
                           fixed
                           width="320">
            <template slot-scope="scope">
              {{ scope.row[1] }}
            </template>
          </el-table-column>
          <el-table-column :label="$t('频率')" align="center" :show-overflow-tooltip="true" fixed width="90">
            <template slot-scope="scope">
              {{ scope.row[2] }}
            </template>
          </el-table-column>
          <el-table-column v-for="(item, index) in companyStaffmgrs" :key="index" :label="item.actualpost"
                           align="center"
                           width="110">
            <el-table-column :key="index" :label="item.name" align="center" width="110">
              <template slot-scope="scope">
                {{ scope.row[index + 3] }}
              </template>
            </el-table-column>
          </el-table-column>
        </el-table>
      </div>
    </vue-draggable-resizable>
  </div>
</template>

<script>
import {
  addTrainingrecords,
  delTrainingrecords,
  exportTrainingrecords,
  exportTrainingTime,
  getTrainingrecords,
  listTrainingrecords,
  updateTrainingrecords
} from "@/api/training/trainingrecords";
import {listTraining} from "@/api/training/worklicense";
import {companyListParticipants, delParticipants, listParticipants} from "@/api/training/participants";
import {deviceListParticipants, listDevice} from "@/api/training/device";
import {treeselect} from "@/api/system/dept";
import {selectTimeStaffmgr} from "@/api/plant/staffmgr";
import {getToken} from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {addCommonfile, allFileList, delCommonfile, updateCommonfile} from "@/api/common/commonfile";
import VueDraggableResizable from 'vue-draggable-resizable';

export default {
  name: "companyRecords",
  components: {Treeselect, VueDraggableResizable},
  mounted() {
    window.onresize = () => {    //写在mounted中,onresize事件会在页面大小被调整时触发
      return (() => {
        window.screenHeight = document.body.clientHeight - 155;
        this.height = window.screenHeight;
      })();
    };
  },
  data() {
    return {
      height: document.body.clientHeight - 155,
      dragMove: true,
      transTitle: [], // transTitle 该标题为转化后的标题, 注意多一列,  因为原来的标题变成了竖着显示了, 所以多一列标题, 第一个为空即可
      companyStaffmgrs: [],
      deviceStaffmgrs: [],
      companylevelList: [],
      devicelevelList: [],
      devicelevelListTemp: [],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 培训成绩表格数据
      trainingrecordsList: [],
      // 人员-公司级培训关系表格数据
      participantsList: [],
      // 人员-装置级培训关系表格数据
      devicceList: [],
      //上岗证培训列表
      worklicenseList: [],
      // 弹出层标题
      title: "",
      companyTitle: "",
      deviceTitle: "",
      companyTrainingTitle: "",
      trainingTimeTitle: "",
      deviceTrainingTitle: "",
      worklicenseTitle: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight: 300,
      // 是否显示弹出层
      open: false,
      companyOpen: false,
      deviceOpen: false,
      companyTrainingOpen: false,
      deviceTrainingOpen: false,
      worklicenseOpen: false,
      companyTrainingLoad: false,
      deviceTrainingLoad: false,
      tableShow: true,
      trainingTimeOpen: false,
      // 装置名称字典
      plantCodeOptions: [],
      // 班值字典
      classesOptions: [],
      // SUB字典
      subOptions: [],
      // 裂解字典
      crackingOptions: [],
      // 热区字典
      hotareaOptions: [],
      // 冷区字典
      coldareaOptions: [],
      // AEU/PGU字典
      aeupguOptions: [],
      // 入职字典
      onboardOptions: [],
      // TDS字典
      tdsOptions: [],
      // 上岗证复证字典
      postCardOptions: [],
      // 工艺培训字典
      craftOptions: [],
      //公司级培训字典
      companyOptions: [],
      //装置级培训字典
      deviceOptions: [],
      // 培训岗位字典
      positionOptions: [],
      //培训类型字典
      trainingTypeOptions: [],
      //点击查看的员工号
      employeeid: '',
      // 用户导入参数
      upload: {
        downloadAction: process.env.VUE_APP_BASE_API + '/common/template',
        //下载模板类型
        type: "trainingrecords",
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/training/trainingrecords/importData"
      },
      // 报告附件参数
      doc: {
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: this.$t('附件'),
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 报告附件上传位置编号
        ids: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/common/commonfile/uploadFile",
        commonfileList: null,
        queryParams: {
          pId: null,
          pType: 'traning'
        },
        pType: 'traning',
        pId: null,
        form: {}
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        name: null,
        employeeid: null,
        classes: null,
        sortDate: null,
        sortOrder: null,
        onboard: null,
        tds: null,
        postCard: null,
        craft: null,
        company: null
      },
      //人员表查询参数
      staffmgrQueryParams: {
        units: "10,18,20,30",
        leftYear: this.getNowTime(),
      },
      queryCompanyParams: {
        staffId: null,
        companyId: null,
      },
      queryDeviceParams: {
        staffId: null,
        regularId: null,
        year: this.getNowTime(),
        trainingType: null
      },
      deviceParams: {
        units: "10,18,20,30",
        staffId: null,
        regularId: null,
        year: null,
        trainingType: null
      },
      worklicenseParams: {
        employeeid: null,
      },
      companyQueryParams: {},
      // 表单参数
      form: {},
      pdf: {
        title: '',
        pdfUrl: '',
        numPages: null,
        open: false,
        pageNum: 1,
        pageTotalNum: 1,
        loadedRatio: 0,
      },
      // 表单校验
      rules: {
        plantCode: [
          {required: true, message: this.$t('装置名称') + this.$t('不能为空'), trigger: "change"}
        ],
        year: [
          {required: true, message: this.$t('年份') + this.$t('不能为空'), trigger: "blur"}
        ],
        deptId: [
          {required: true, message: this.$t('部门编号') + this.$t('不能为空'), trigger: "blur"}
        ]
      },
    };

  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    },
    height(val) {        //在watch中监听height,浏览器窗口大小变动时自适应高度。
      this.height = val;
      console.log(this.height, "新的高度");
    },
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = (document.body.clientHeight - 80) * 0.8
    })
    this.getList();
    this.handleDevice();
    this.getStaffmar();
    this.getTreeselect();
    this.handleCompany();
    this.getDicts("PLANT_DIVIDE").then(response => {
      this.plantCodeOptions = response.data;
    });
    this.getDicts("TEAM_DIVIDE").then(response => {
      this.classesOptions = response.data;
    });
    this.getDicts("TICK_CROSS").then(response => {
      this.subOptions = response.data;
    });
    this.getDicts("TICK_CROSS").then(response => {
      this.crackingOptions = response.data;
    });
    this.getDicts("TICK_CROSS").then(response => {
      this.hotareaOptions = response.data;
    });
    this.getDicts("TICK_CROSS").then(response => {
      this.coldareaOptions = response.data;
    });
    this.getDicts("TICK_CROSS").then(response => {
      this.aeupguOptions = response.data;
    });
    this.getDicts("TRAINING_QUALIFY").then(response => {
      this.onboardOptions = response.data;
    });
    this.getDicts("TRAINING_QUALIFY").then(response => {
      this.tdsOptions = response.data;
    });
    this.getDicts("TRAINING_QUALIFY").then(response => {
      this.postCardOptions = response.data;
    });
    this.getDicts("TRAINING_QUALIFY").then(response => {
      this.craftOptions = response.data;
    });
    this.getDicts("TRAINING_QUALIFY").then(response => {
      this.companyOptions = response.data;
    });
    this.getDicts("TRAINING_QUALIFY").then(response => {
      this.deviceOptions = response.data;
    });
    this.getDicts("ACTUALPOST").then(response => {
      this.positionOptions = response.data;
    });
    this.getDicts("TRAINING_TYPE").then(response => {
      this.trainingTypeOptions = response.data;
    });
  },
  methods: {
    onResize(event, {width, height}) {
      console.log(height)
    },
    handleTableWheel(event) {
      let obj = this.$refs['branch']
      return this.tableZoom(obj, event)
    },
    tableZoom(obj, event) {
      // 一开始默认是100%
      let zoom = parseInt(obj.style.zoom, 10) || 100
      // 滚轮滚一下wheelDelta的值增加或减少120
      zoom += event.wheelDelta / 12
      if (zoom > 25) {
        obj.style.zoom = zoom + '%'
      }
      this.height=document.body.clientHeight-100
      return false
    },
    colspanMethod({row, column, rowIndex, columnIndex}) {
      if (columnIndex === 0) {
        const _row = this.setTable(this.companylevelList).merge[rowIndex];
        const _col = _row > 0 ? 1 : 0;
        return {
          rowspan: _row,
          colspan: _col
        };
      }
      if (columnIndex === 1) {
        const _row = this.setTable(this.companylevelList).merge[rowIndex];
        const _col = _row > 0 ? 1 : 0;
        return {
          rowspan: _row,
          colspan: _col
        };
      }
      if (columnIndex === 2) {
        const _row = this.setTable(this.companylevelList).merge[rowIndex];
        const _col = _row > 0 ? 1 : 0;
        return {
          rowspan: _row,
          colspan: _col
        };
      }
    },
    colspanDeviceMethod({row, column, rowIndex, columnIndex}) {
      if (columnIndex === 0) {
        const _row = this.setTable(this.devicelevelList).merge[rowIndex];
        const _col = _row > 0 ? 1 : 0;
        return {
          rowspan: _row,
          colspan: _col
        };
      }
      if (columnIndex === 1) {
        const _row = this.setTable(this.devicelevelList).merge[rowIndex];
        const _col = _row > 0 ? 1 : 0;
        return {
          rowspan: _row,
          colspan: _col
        };
      }
    },
    setTable(tableData) {
      let spanArr = [],
          concat = 0;
      tableData.forEach((item, index) => {
        if (index === 0) {
          spanArr.push(1);
        } else {
          if (item[1] === tableData[index - 1][1] && item[0] === tableData[index - 1][0]) {
            //第一列需合并相同内容的判断条件
            spanArr[concat] += 1;
            spanArr.push(0);
          } else {
            spanArr.push(1);
            concat = index;
          }
        }
      });
      return {
        merge: spanArr
      };
    },
    //根据是否存在最后培训时间显示颜色提示
    tableCellClassName({row, column, rowIndex, columnIndex}) {
      // for (let i = 2; i < this.transTitle.length + 2; i++) {
      //   if (columnIndex == i){
      //     return this.changeColor(row[i])
      //   }
      // }
      return this.changeColor(row[columnIndex])
    },
    changeColor(value) {
      if (value == null) {
        return 'companyNot'
      }
      if (value.trim().startsWith('20')) {
        return 'companyFinish'
      }
      if (value === "-") {
        return 'companyUrgent'
      }
      if (value === "尚未开始培训") {
        return 'companyNot'
      }
    },
    /** 查询培训成绩列表 */
    getList() {
      this.loading = true;
      listTrainingrecords(this.queryParams).then(response => {
        this.trainingrecordsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    //获取人员表
    getStaffmar() {
      selectTimeStaffmgr(this.staffmgrQueryParams).then(response => {
        const allData = response.rows
        const data = [];
        for (let i = 0; i < allData.length; i++) {
          data.push({
            name: allData[i].name,
            actualpost: this.selectDictLabel(this.positionOptions, allData[i].actualpost),
            trainingTime: allData[i].trainingTime
          });
        }
        this.transTitle = data;
      })
    },
    //获取公司级培训列表
    getCompanyTraining() {
      companyListParticipants(this.companyQueryParams).then(response => {
        this.companylevelList = response.companyLevelList
        const allData = response.staffmgrs
        const data = [];
        for (let i = 0; i < allData.length; i++) {
          data.push({
            name: allData[i].name,
            actualpost: this.selectDictLabel(this.positionOptions, allData[i].actualpost),
          });
        }
        this.companyStaffmgrs = data
        this.companyTrainingLoad = false
        this.$nextTick(() => {
          this.$refs.companyTable.doLayout(); // 解决表格错位
        });
      })
    },
    //获取装置级培训列表
    getDeviceTraining() {
      deviceListParticipants(this.deviceParams).then(response => {
        this.devicelevelList = response.deviceLevelList
        const allData = response.staffmgrs
        const data = [];
        for (let i = 0; i < allData.length; i++) {
          data.push({
            name: allData[i].name,
            actualpost: this.selectDictLabel(this.positionOptions, allData[i].actualpost),
          });
        }
        this.deviceStaffmgrs = data
        this.deviceTrainingLoad = false
        this.$nextTick(() => {
          this.$refs.deviceTable.doLayout(); // 解决表格错位
        });
      })
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 装置名称字典翻译
    plantCodeFormat(row, column) {
      return this.selectDictLabel(this.plantCodeOptions, row.plantCode);
    },
    // 班值字典翻译
    classesFormat(row, column) {
      return this.selectDictLabel(this.classesOptions, row.classes);
    },
    // SUB字典翻译
    subFormat(row, column) {
      return this.selectDictLabel(this.subOptions, row.sub);
    },
    // 裂解字典翻译
    crackingFormat(row, column) {
      return this.selectDictLabel(this.crackingOptions, row.cracking);
    },
    // 热区字典翻译
    hotareaFormat(row, column) {
      return this.selectDictLabel(this.hotareaOptions, row.hotarea);
    },
    // 冷区字典翻译
    coldareaFormat(row, column) {
      return this.selectDictLabel(this.coldareaOptions, row.coldarea);
    },
    // AEU/PGU字典翻译
    aeupguFormat(row, column) {
      return this.selectDictLabel(this.aeupguOptions, row.aeupgu);
    },
    // 入职字典翻译
    onboardFormat(row, column) {
      return this.selectDictLabel(this.onboardOptions, row.onboard);
    },
    // TDS字典翻译
    tdsFormat(row, column) {
      return this.selectDictLabel(this.tdsOptions, row.tds);
    },
    // 上岗证复证字典翻译
    postCardFormat(row, column) {
      return this.selectDictLabel(this.postCardOptions, row.postCard);
    },
    // 工艺培训字典翻译
    craftFormat(row, column) {
      return this.selectDictLabel(this.craftOptions, row.craft);
    },
    //公司级培训字典翻译
    companyFormat(row, column) {
      return this.selectDictLabel(this.companyOptions, row.company);
    },
    //装置级培训字典翻译
    deviceFormat(row, column) {
      return this.selectDictLabel(this.deviceOptions, row.device);
    },
    // 培训类型翻译
    trainingTypeFormat(row, column) {
      return this.selectDictLabel(this.trainingTypeOptions, row.trainingType);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        plantCode: null,
        name: null,
        employeeid: null,
        classes: null,
        companysafe: null,
        plantsafe: null,
        teamsafe: null,
        sub: null,
        cracking: null,
        hotarea: null,
        coldarea: null,
        aeupgu: null,
        upscore: null,
        downscore: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        remarks: null,
        deptId: null,
        onboard: null,
        tds: null,
        postCard: null,
        craft: null,
        company: null,
        device: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    //搜索按钮
    handleDeviceQuery() {
      this.deviceTrainingLoad = true;
      this.$nextTick(() => {
        this.getDeviceTraining();
      });
    },
    staffDeviceQuery() {
      this.getDevice(this.employeeid)
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    //根据分数显示颜色提示
    tableCellStyle({row, column, rowIndex, columnIndex}) {
      if (columnIndex === 4 && row.onboard === "2") {
        return "color: rgba(255, 26, 26, 0.98) "
      } else if (columnIndex === 5 && row.tds === "2") {
        return "color: rgba(255, 26, 26, 0.98) "
      } else if (columnIndex === 6 && row.postCard === "2") {
        return "color: rgba(255, 26, 26, 0.98) "
      } else if (columnIndex === 7 && row.craft === "2") {
        return "color: rgba(255, 26, 26, 0.98) "
      } else if (columnIndex === 8 && row.company === "2") {
        return "color: rgba(255, 26, 26, 0.98) "
      }
    },
    //排序
    sortChange(val) {
      if (val.prop == 'companysafe') {
        this.queryParams.sortDate = 'companysafe';
      } else if (val.prop == 'plantsafe') {
        this.queryParams.sortDate = 'plantsafe';
      } else if (val.prop == 'teamsafe') {
        this.queryParams.sortDate = 'teamsafe';
      }
      if (val.order === 'descending') {
        this.queryParams.sortOrder = 'desc'
      } else {
        this.queryParams.sortOrder = 'asc'
      }
      this.getList()
    },
    /** 获取当前年份 */
    getNowTime() {
      var now = new Date();
      var year = now.getFullYear(); //得到年份
      var defaultDate = `${year}`;
      defaultDate = `${year}`
      return defaultDate;
    },
    /** 公司级培训矩阵按钮操作 */
    handleCompany() {
      this.companyTrainingLoad = true
      this.companyTrainingTitle = this.$t('参加') + this.$t('空格') + this.$t('公司级') + this.$t('空格') + this.$t('培训人员') + this.$t('空格') + this.$t('名单')
      this.companyTrainingOpen = true
      // loading.close();
      this.tableShow = true
      setTimeout(() => {
        this.getCompanyTraining();
      }, 10);
    },
    /** 装置级培训矩阵按钮操作 */
    handleDevice() {
      this.deviceTrainingLoad = true
      this.resetForm("queryRegularForm");
      this.deviceTrainingTitle = this.$t('参加') + this.$t('空格') + this.$t('装置级') + this.$t('空格') + this.$t('培训人员') + this.$t('空格') + this.$t('名单')
      this.deviceTrainingOpen = true
      this.tableShow = true
      this.deviceParams.year = this.getNowTime();
      // this.$nextTick(() => {
      //   deviceListParticipants(this.deviceParams).then(response => {
      //     this.devicelevelListTemp = response;
      //     this.devicelevelList = response
      //     this.deviceTrainingLoad = false
      //     this.$nextTick(() => {
      //       this.$refs.deviceTable.doLayout(); // 解决表格错位
      //     });
      //   })
      // });
      setTimeout(() => {
        this.getDeviceTraining();
      }, 10);
    },
    /** 人员培训时长按钮操作 */
    handleTime() {
      this.trainingTimeOpen = true;
      this.trainingTimeTitle = this.$t('人员培训时长');
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t('新增') + this.$t('空格') + this.$t('培训成绩');
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getTrainingrecords(id).then(response => {
        this.form = response.data;
        if (response.data.sub == 10) {
          this.form.sub = true
        }
        if (response.data.cracking == 10) {
          this.form.cracking = true
        }
        if (response.data.hotarea == 10) {
          this.form.hotarea = true
        }
        if (response.data.coldarea == 10) {
          this.form.coldarea = true
        }
        if (response.data.aeupgu == 10) {
          this.form.aeupgu = true
        }
        this.open = true;
        this.title = this.$t('修改') + this.$t('培训成绩');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateTrainingrecords(this.form).then(response => {
              this.msgSuccess(this.$t('修改成功'));
              this.open = false;
              this.getList();
            });
          } else {
            addTrainingrecords(this.form).then(response => {
              this.msgSuccess(this.$t('新增成功'));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function () {
        return delTrainingrecords(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess(this.$t('删除成功'));
      })
    },
    /** 公司级培训删除按钮操作 */
    participantsHandleDelete(row) {
      const ids = row.id
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function () {
        return delParticipants(ids);
      }).then(() => {
        this.getParticipants(row.staffId)
        this.msgSuccess(this.$t('删除成功'));
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm(this.$t('是否确认导出所有培训成绩数据项?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function () {
        return exportTrainingrecords(queryParams);
      }).then(response => {
        this.download(response.msg);
      })
    },
    /** 导出人员培训时长按钮操作 */
    exportTrainingTime() {
      const queryParams = this.transTitle;
      this.$confirm(this.$t('是否确认导出人员培训时长?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function () {
        return exportTrainingTime();
      }).then(response => {
        this.download(response.msg);
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = this.$t('用户导入');
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      this.$refs['downloadFileForm'].submit()
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      if (response.data[0] != null) {
        this.$alert(this.$t('成功导入') + response.msg + this.$t('条数据') + "，" + this.$t('第') + response.data + this.$t('行数据出现错误导入失败') + "。", this.$t('导入结果'), {dangerouslyUseHTMLString: true});
      } else {
        this.$alert(this.$t('成功导入') + response.msg + this.$t('条数据'), this.$t('导入结果'), {dangerouslyUseHTMLString: true});
      }
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    /** 报告附件按钮操作 */
    handleDoc(row, fileType) {
      this.doc.pType = fileType
      this.doc.queryParams.pType = fileType
      this.doc.id = row.id;
      var titleType = '';
      if (fileType === 'trainingrecords-onbord') {
        titleType = row.name + this.$t('空格') + this.$t('的') + this.$t('入职') + this.$t('空格') + this.$t('培训')
      } else if (fileType === 'trainingrecords-tds') {
        titleType = row.name + this.$t('空格') + this.$t('的') + this.$t('TDS培训')
      } else if (fileType === 'trainingrecords-craft') {
        titleType = row.name + this.$t('空格') + this.$t('的') + this.$t('工艺培训')
      } else {
        titleType = this.$t('上岗证') + this.$t('空格') + this.$t('培训')
      }
      this.doc.title = titleType;
      this.doc.open = true;
      this.doc.queryParams.pId = row.id
      this.doc.pId = row.id
      this.getFileList()
      this.$nextTick(() => {
        this.$refs.doc.clearFiles()
      })
    },
    getFileList() {
      allFileList(this.doc.queryParams).then(response => {
        response.forEach(element => {
          element["isEdit"] = false
        });
        response.forEach(element => {
          element["isAdd"] = false
        });
        this.doc.commonfileList = response;
      });
    },
    //附件上传中处理
    handleFileDocProgress(event, file, fileList) {
      this.doc.file = file;
      this.doc.isUploading = true;
    },
    //附件上传成功处理
    handleFileDocSuccess(response, file, fileList) {
      this.doc.isUploading = false;
      this.$alert(response.msg, this.$t('导入结果'), {dangerouslyUseHTMLString: true});
      this.getFileList()
    },
    // 文件下载处理
    handleDownload(row) {
      var name = row.fileName;
      var url = row.fileUrl;
      var suffix = url.substring(url.lastIndexOf("."), url.length);
      const a = document.createElement('a')
      a.setAttribute('download', name)
      a.setAttribute('target', '_blank')
      a.setAttribute('href', process.env.VUE_APP_BASE_API + url)
      a.click()
    },
    //pdf预览
    openPdf() {
      window.open(this.pdf.pdfUrl);//path是文件的全路径地址
    },
    handleSee(row) {
      this.pdf.open = true
      this.pdf.title = row.fileName
      this.pdf.pdfUrl = process.env.VUE_APP_BASE_API + '/pdf/web/viewer.html?file=' + process.env.VUE_APP_BASE_API + row.fileUrl
    },
    /** 打开上岗证复证列表 */
    openWorklicense(row) {
      this.worklicenseOpen = true;
      this.worklicenseTitle = row.name + this.$t('的') + this.$t('上岗证复证') + this.$t('列表');
      this.worklicenseParams.employeeid = row.employeeid
      listTraining(this.worklicenseParams).then(response => {
        this.worklicenseList = response;
      });
    },
    /** 打开公司级培训列表 */
    openCompany(row) {
      this.companyOpen = true;
      this.companyTitle = row.name + this.$t('空格') + this.$t('的') + this.$t('公司级') + this.$t('空格') + this.$t('培训信息');
      this.$nextTick(() => {
        this.getParticipants(row.employeeid)
      })
    },
    /** 打开装置级培训列表 */
    openDevice(row) {
      this.deviceOpen = true;
      this.resetForm("queryRegularForm");
      this.deviceTitle = row.name + this.$t('空格') + this.$t('的') + this.$t('装置级') + this.$t('空格') + this.$t('培训信息');
      this.employeeid = row.employeeid;
      this.queryDeviceParams.year = this.getNowTime();
      this.$nextTick(() => {
        this.getDevice(row.employeeid)
      })
    },
    getParticipants(employeeid) {
      this.queryCompanyParams.staffId = employeeid
      listParticipants(this.queryCompanyParams).then(response => {
        this.participantsList = response.rows;
      });
    },
    getDevice(employeeid) {
      this.queryDeviceParams.staffId = employeeid
      listDevice(this.queryDeviceParams).then(response => {
        this.devicceList = response.rows;
      });
    },
    // 取消
    cancelFile(row, index) {
      // 如果是新增的数据
      if (row.isAdd) {
        this.doc.commonfileList.splice(index, 1)
      } else {
        // 不是新增的数据  还原数据
        for (const i in row.oldRow) {
          row[i] = row.oldRow[i]
        }
        row.isEdit = false
      }
    },
    edit(row) {
      // 备份原始数据
      row['oldRow'] = JSON.parse(JSON.stringify(row));
      this.$nextTick(() => {
        row.isEdit = true;
      })
    },
    save(row) {
      row.isEdit = false;
      var that = this;
      that.loading = true;
      this.form = row;
      if (row.isAdd == true) {
        addCommonfile(this.form).then(response => {
          this.msgSuccess(this.$t('新增成功'));
          this.open = false;
          this.getList();
        });
      } else {
        updateCommonfile(this.form).then(response => {
          this.msgSuccess(this.$t('修改成功'));
          this.open = false;
          this.getList();
        });
      }
    },
    /** 删除按钮操作 */
    handleDeleteDoc(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function () {
        return delCommonfile(ids);
      }).then(() => {
        this.getFileList()
        this.msgSuccess(this.$t('删除成功'));
      })
    },

    /** 公司级培训修改按钮操作 */
    handleCompanyUpdate(row) {
      this.reset();
      const id = row.id || this.ids
    },
    closeDialog() {
      this.companylevelList = []
      this.devicelevelList = []
      this.tableShow = false
    },
  }
};
</script>

<style>
.companyLevelTable {
  color: black;
}

::v-deep.el-table tbody tr:hover > td {
  background-color: transparent !important;
}

.el-dialog__body {
  padding-top: 0px
}

.el-table--scrollable-x .el-table__body-wrapper {
  z-index: 1;
}

.rectangleRed {
  width: 60px !important;
  height: 30px !important;
  margin-bottom: -8px;
}

.rectangleGreen {
  width: 60px !important;
  height: 30px !important;
  margin-bottom: -8px;
}


</style>


